function varargout = RegFilterConfiguration(varargin)
% REGFILTERCONFIGURATION MATLAB code for RegFilterConfiguration.fig
%      REGFILTERCONFIGURATION, by itself, creates a new REGFILTERCONFIGURATION or raises the existing
%      singleton*.
%
%      H = REGFILTERCONFIGURATION returns the handle to a new REGFILTERCONFIGURATION or the handle to
%      the existing singleton*.
%
%      REGFILTERCONFIGURATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in REGFILTERCONFIGURATION.M with the given input arguments.
%
%      REGFILTERCONFIGURATION('Property','Value',...) creates a new REGFILTERCONFIGURATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RegFilterConfiguration_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RegFilterConfiguration_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RegFilterConfiguration

% Last Modified by GUIDE v2.5 19-Sep-2015 15:57:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @RegFilterConfiguration_OpeningFcn, ...
    'gui_OutputFcn',  @RegFilterConfiguration_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before RegFilterConfiguration is made visible.
function RegFilterConfiguration_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RegFilterConfiguration (see VARARGIN)

% Choose default command line output for RegFilterConfiguration
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
global cellmatrix exportmat
cellmatrix = cell2mat(varargin(1));
filtercolumnformat=get(handles.filterconfig,'ColumnFormat');
set(handles.filterconfig,'ColumnFormat',filtercolumnformat);
set(handles.popupmenu_NormalizationMode,'String',{'0.4-max CorrCoeff -> Alpha 0.1-0.8', 'ABS(min-max CorrCoeff)-> Alpha 0.1-0.8'});
set(handles.popupmenu_colorbarc,'String',{'Blue','Green','Red','Cyan','Magenta','Yellow'});

% UIWAIT makes RegFilterConfiguration wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = RegFilterConfiguration_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
global filtersettings exportmat cellmatrix region showlegend h_cam


filtersettings=get(handles.filterconfig,'Data');
regselect=filtersettings(:,1:2);
regselect(:,2)=cellfun(@str2num,regselect(:,2),'UniformOutput',0);
output=cellmatrix;
output(:,4:5)=0;
for g=1:size(regselect,1)
    if regselect{g,1}
        matchind=find(ismember(cellfun(@(x) x(2),exportmat(:,13)),regselect{g,2}));
        output(matchind,4)=g+1;
        corrcoeff=cellfun(@(x) x(1),exportmat(:,13));
        output(matchind,5)=corrcoeff(matchind);
    end
end
clear filternames
filternames(1:7,1)={num2str(horzcat(filtersettings{1,2})); num2str(horzcat(filtersettings{2,2})); num2str(horzcat(filtersettings{3,2})); num2str(horzcat(filtersettings{4,2})); num2str(horzcat(filtersettings{5,2})); num2str(horzcat(filtersettings{6,2})); num2str(horzcat(filtersettings{7,2}))};

for k=1:size(filternames,1)
    if isempty(filternames{k,1})
       filternames{k,1}='not specified';
    end
end
if get(handles.checkbox_alphacoding,'Value')==0    
    output(:,5)=0.5;    
else
    cmap=flipud(gray(64));
    if get(handles.checkbox_normAlphaRange,'Value')==1
        cmap=cmap*0.7+0.1;
        switch get(handles.popupmenu_NormalizationMode,'Value')
            case 1; % '0.4-max CorrCoeff -> Alpha 0.1-0.8'
                prenormrange=(max(output(:,5))-0.4);
                newcaxis=[0.4 max(output(:,5))];
                output(:,5)=output(:,5)*(0.7/prenormrange)-0.4*(0.7/prenormrange)+0.1;
                output(output(:,5)<0,5)=0;
                
            case 2; % 'ABS(min-max CorrCoeff)-> Alpha 0.1-0.8'
                prenormrange=max(abs(output(:,5)))-min(abs(output(:,5)));
                newcaxis=[min(abs(output(:,5))) max(abs(output(:,5)))];
                output(:,5)=abs(output(:,5))*(0.7/prenormrange)-min(abs(output(:,5)))*(0.7/prenormrange)+0.1;
                output(output(:,5)<0,5)=0;
        end
    output((output(:,4)==8),5)=0.3; % set grey cells to fixed low alpha value
    end
    
        switch get(handles.popupmenu_colorbarc,'Value')
        case 1;
        cmap(1:end,3)=1; % tint colorbar blue
        case 2;
        cmap(1:end,2)=1; % tint colorbar green
        case 3;
        cmap(1:end,1)=1; % tint colorbar red
        case 4;
        cmap(1:end,2:3)=1; % tint colorbar cyan
        case 5;
        cmap(1:end,[1,3])=1; % tint colorbar magenta
        case 6;
        cmap(1:end,[1,2])=1; % tint colorbar yellow
    end
    
end

shownumbershandle=findobj('Tag','checkbox_shownumbers');
h_cam=show3dposition_5_131005(output,get(shownumbershandle,'Value'),region,showlegend,filternames);
if showlegend && get(handles.checkbox_alphacoding,'Value')==1
figure(98)

colormap(cmap);
colorbar('Location','EastOutside');
caxis(newcaxis);
end

% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox_alphacoding.
function checkbox_alphacoding_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_alphacoding (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkbox_alphacoding


% --- Executes on button press in checkbox_normAlphaRange.
function checkbox_normAlphaRange_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_normAlphaRange (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_normAlphaRange


% --- Executes on selection change in popupmenu_NormalizationMode.
function popupmenu_NormalizationMode_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_NormalizationMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_NormalizationMode contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_NormalizationMode


% --- Executes during object creation, after setting all properties.
function popupmenu_NormalizationMode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_NormalizationMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_colorbarc.
function popupmenu_colorbarc_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_colorbarc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_colorbarc contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_colorbarc


% --- Executes during object creation, after setting all properties.
function popupmenu_colorbarc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_colorbarc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function filterconfig_CreateFcn(hObject, eventdata, handles)
% hObject    handle to filterconfig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
