function [line_x_fit,line_y_fit,R_square]=fit_gauss3(line_x_ori,line_y_ori)

% fit data with 'gauss3'
% inputs: line_x_ori    x values to be fitted       standard x values 
%          line_y_ori   y values to be fitted
% outputs: line_x_fit   x values to be fitted       standard x values        
%          line_y_fit   y values to be fitted
%          R square

ft = fittype( 'gauss3' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );


line_x_fit=1:512;
line_x_fit=line_x_fit';
[fitresult, gof] = fit(line_x_ori, line_y_ori, ft, opts );

line_y_fit=fitresult.a1*exp(-power(((line_x_fit-fitresult.b1)/fitresult.c1),2)) + fitresult.a2*exp(-power(((line_x_fit-fitresult.b2)/fitresult.c2),2)) +... 
              fitresult.a3*exp(-power(((line_x_fit-fitresult.b3)/fitresult.c3),2));
R_square=gof.rsquare;