function [HfigAndAxes] = stacksalign()
hMainFigure = figure(...       % The main GUI figure
    'MenuBar','none', ...  
    'Toolbar','none', ...
    'HandleVisibility','callback', ...
    'Position', [100 100 900 300], ...
    'Color', get(0,...
    'defaultuicontrolbackgroundcolor')); ...
    fighandle=gcf;

%% Generate Axes
hStackPlotAxes = axes(...      % Axes for plotting the Stack
    'Parent', hMainFigure, ...
    'Units', 'normalized', ...
    'HandleVisibility','callback', ...
    'yticklabel', []); ...
    title('Stack');
    stackaxis=gca;

HfigAndAxes=[fighandle, stackaxis];


%% Image Menu
hImageMenu      =   uimenu(...          % Image
    'Parent',hMainFigure,...
    'HandleVisibility','callback', ...
    'Label','Image');
hadjStackContrast  =   uimenu(...       % Adjust stack contrast
    'Parent',hImageMenu,...
    'Label','Adjust stack contrast',...
    'HandleVisibility','callback', ...
    'Callback', {@hAdjStackContrast HfigAndAxes});
end

function hAdjStackContrast(~, ~, HfigAndAxes)
figure(HfigAndAxes(1));
axes(HfigAndAxes(2));
imcontrast;
end
